#!/bin/bash

version="1.0"
eclipse_dir=eclipse
if [ ! -d ${eclipse_dir} ]; then
    echo "0. Downloading eclipse ..."
    platform=`uname -m`
    if [ `uname -s` == "Darwin" ]; then
        # Assume x64
        wget http://archive.eclipse.org/technology/epp/downloads/release/helios/SR2/eclipse-jee-helios-SR2-macosx-cocoa-x86_64.tar.gz
    elif [ "${platform}" = "x86_64" ]; then
        wget http://archive.eclipse.org/technology/epp/downloads/release/helios/SR2/eclipse-jee-helios-SR2-linux-gtk-x86_64.tar.gz
    else
        wget http://archive.eclipse.org/technology/epp/downloads/release/helios/SR2/eclipse-jee-helios-SR2-linux-gtk.tar.gz
    fi
    tar xfz eclipse*.gz
fi
ECLIPSE_HOME=`pwd`/${eclipse_dir}
ECLIPSE_LAUNCHER=`find ${ECLIPSE_HOME} -type f -name "*equinox.launcher_*.jar"`
ECLIPSE_SCRIPTS=`find ${ECLIPSE_HOME} -type d -name "scripts" | grep 'build'`

tmp_dir=`pwd`/tmp/
plugin_build_dir="${tmp_dir}"
plugin_template_dir="./plugin.build"

# Build CoCo Plugin
rm -rf ${plugin_build_dir}
mkdir -p ${plugin_build_dir}
cp -r ${plugin_template_dir}/* ${plugin_build_dir}
cp -r ${plugin_template_dir}/build.properties.template ${plugin_build_dir}/build.properties
s=`pwd | sed "s/\//\\\\\\\\\//g"`
sed -i "s/ECLIPSE_BASE/""${s}""/g" ${plugin_build_dir}/build.properties
sed -i "s/ECLIPSE_NAME/eclipse/g" ${plugin_build_dir}/build.properties
s=`echo ${plugin_build_dir} | sed "s/\//\\\\\\\\\//g"`
sed -i "s/COVERAGE_TMP/""${s}""/g" ${plugin_build_dir}/build.properties
rm -rf ${plugin_build_dir}/plugins/
mkdir -p ${plugin_build_dir}/plugins/
cp -r coco-plugin ${plugin_build_dir}/plugins/coco

java -jar ${ECLIPSE_LAUNCHER} \
    -application org.eclipse.ant.core.antRunner \
    -buildfile ${ECLIPSE_SCRIPTS}/build.xml \
    -Dbuilder=${plugin_build_dir}
cp ${plugin_build_dir}plugins/coco/coco_1.0.0.jar ${eclipse_dir}/plugins/coco-plugin-${version}.jar

## Build CoCo Runtime
( cd coco-runtime; ant dist )
