package coco.log;

import java.io.FileNotFoundException;
import java.io.PrintWriter;

/**
 * Simple class for logging.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 */
public class Log {

    private static PrintWriter pw;

    public static void open(String fileName) {
        try {
            pw = new PrintWriter(fileName);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    public static void close() {
        if (pw != null) {
            pw.flush();
            pw.close();
        }
    }

    public static void m(String msg) {
        p("M", msg);
    }

    public static void d(String msg) {
        p("D", msg);
    }

    public static void w(String msg) {
        p("W", msg);
    }

    public static void e(String msg) {
        p("E", msg);
    }

    private static synchronized void p(String prefix, String msg) {
        if (pw != null) {
            pw.println(prefix + ":: " + msg);
            pw.flush();
        }
    }
}
