package coco.task;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;

/**
 * An instance of {@link NullProgressMonitor}. (Avoids creating a number of
 * instances.)
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 */
public class EmptyProgressMonitor {

    private static NullProgressMonitor inst = new NullProgressMonitor();

    private EmptyProgressMonitor() {
    }

    public static IProgressMonitor inst() {
        return inst;
    }

}
