package coco.task;

import org.eclipse.ltk.core.refactoring.RefactoringStatusEntry;

/**
 * Refactoring execution report.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 */
public class ProblemReport {

    private RefactoringStatusEntry[] entries;

    public void addProblems(RefactoringStatusEntry[] e) {
        entries = e;
    }

    public RefactoringStatusEntry[] getProblems() {
        return entries;
    }

    public boolean hasError() {
        if (entries != null) {
            for (RefactoringStatusEntry e : entries) {
                if (e.isError() || e.isFatalError()) {
                    return true;
                }
            }
        }
        return false;
    }

    public void printProblems() {
        if (entries != null) {
            for (RefactoringStatusEntry e : entries) {
                System.out.println(e);
            }
        }
    }
}
