package coco.task.etc;

import org.eclipse.jdt.core.dom.Block;

import coco.util.ICUCompiler.ICUCompilerResult;

/**
 * Removing errors that may exist after instrumentation.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 */
public class RemoveUnreachableBlocksASTV extends RemoveErrorsASTV {

    private static final String ERR_MSG = "Unreachable code";

    public RemoveUnreachableBlocksASTV(ICUCompilerResult compilerResult) {
        super(compilerResult, ERR_MSG);
    }

    // ASTVisitor interface

    @Override
    public boolean visit(Block node) {
        if (errorCodeStarts.contains(node.getStartPosition())) {
            node.delete();
        }
        return true;
    }
}
