package coco.task.extract.pct;

import org.eclipse.jdt.core.dom.AssertStatement;
import org.eclipse.jdt.core.dom.DoStatement;
import org.eclipse.jdt.core.dom.ForStatement;
import org.eclipse.jdt.core.dom.IfStatement;
import org.eclipse.jdt.core.dom.WhileStatement;

/**
 * Extract conditions from conditional statements. The condition is taken as it
 * is.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 * 
 * @see DetectAtomicConditionsASTV
 */
class DetectCompositeConditionsASTV extends DetectConditionsASTV {

    public DetectCompositeConditionsASTV(DetectPureMethodsASTV pureVisitor) {
        super(pureVisitor);
    }

    // ASTVisitor interface

    @Override
    public boolean visit(AssertStatement node) {
        visitCondition(node.getExpression());
        return true;
    }

    @Override
    public boolean visit(DoStatement node) {
        visitCondition(node.getExpression());
        return true;
    }

    @Override
    public boolean visit(ForStatement node) {
        if (node.getExpression() != null) {
            visitCondition(node.getExpression());
        }
        return true;
    }

    @Override
    public boolean visit(IfStatement node) {
        visitCondition(node.getExpression());
        return true;
    }

    @Override
    public boolean visit(WhileStatement node) {
        visitCondition(node.getExpression());
        return true;
    }

}
