package coco.task.extract.pct;

import org.eclipse.jdt.core.dom.Expression;

import coco.util.CoCoUtil;

/**
 * Extract conditions from conditional statements.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 * 
 * @see ExtractPredicatesTask
 */
abstract class DetectConditionsASTV extends DetectXASTV {

    public DetectConditionsASTV(DetectPureMethodsASTV pureVisitor) {
        super(pureVisitor);
    }

    @SuppressWarnings("deprecation")
    protected final void visitCondition(Expression expr) {
        getCallGraphASTVisitor().setCurrentType(stackOfTypes.peek());
        expr.accept(getCallGraphASTVisitor());
        if (!getCallGraphASTVisitor().isPure()) {
            return;
        }
        internalCounter++;
        if (internalCounter == currentConditionId && !hasCondition) {
            if (!CoCoUtil.isConditionInvocation(expr)) {
                hasCondition = true;
            }
            expression = expr;
            currentConditionId++;
        }
    }

}
