package coring;

/**
 * {@link Opt} of type {@link Boolean}.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public final class BooleanOpt extends Opt<Boolean> {

    public BooleanOpt(String name) {
        this(name, null);
    }

    public BooleanOpt(String name, String shortName) {
        super(name, shortName, Boolean.class, false);
    }

    @Override
    protected void setVal(String[] args, int index) {
        s(true);
    }

    @Override
    protected String getArgArgumentString() {
        return "";
    }

    @Override
    public BooleanOpt s(Boolean v) {
        unsafeSet(v);
        return this;
    }
}
