package coring;

import java.util.ArrayList;
import java.util.List;

/**
 * {@link Opt}s of type {@link List<Integer>}.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public class IntegerLst extends Opt<List<Integer>> {

    public IntegerLst(String name) {
        this(name, null);
    }

    public IntegerLst(String name, String shortName) {
        super(name, shortName, List.class, null);
    }

    @Override
    protected void setVal(String[] args, int index) {
        String[] vals = args[index + 1].split(OptConfig.LIST_SEPARATOR);
        List<Integer> list = new ArrayList<Integer>();
        for (String val : vals) {
            list.add(Integer.parseInt(val));
        }
        s(list);
    }

    @Override
    protected String getArgArgumentString() {
        return "INTEGER_0,INTEGER_1,...,INTEGER_N";
    }

    @Override
    public IntegerLst s(List<Integer> v) {
        unsafeSet(v);
        return this;
    }
}
