package coring;

/**
 * {@link Opt} of type {@link Integer}.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public final class IntegerOpt extends Opt<Integer> {

    public IntegerOpt(String name) {
        this(name, null);
    }

    public IntegerOpt(String name, String shortName) {
        super(name, shortName, Integer.class, 0);
    }

    @Override
    protected void setVal(String[] args, int index) {
        s(Integer.parseInt(args[index + 1]));
    }

    @Override
    protected String getArgArgumentString() {
        return "INTEGER";
    }

    @Override
    public IntegerOpt s(Integer v) {
        unsafeSet(v);
        return this;
    }
}
