package coring;

/**
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public class Newcommand {

    public static String makeUseMacro(String string) {
        return "\\" + transform(string);
    }

    public static String makeHline() {
        return "\\hline";
    }

    public static String makeHlineDup() {
        return (makeHline() + "\n" + makeHline());
    }

    public static String makeNewcommand(String command, int value) {
        return makeNewcommand(command, Integer.toString(value));
    }

    public static String makeNewcommand(String command, double value) {
        return makeNewcommand(command, Double.toString(value));
    }

    public static String makeNewcommand(String command) {
        return makeNewcommand(command, "");
    }

    public static String makeNewcommand(String command, String value) {
        return "\\newcommand{\\" + transform(command) + "}{" + value + "}";
    }

    public static String transform(String s) {
        s = s.replaceAll("0", "Ze");
        s = s.replaceAll("1", "On");
        s = s.replaceAll("2", "Tw");
        s = s.replaceAll("3", "Th");
        s = s.replaceAll("4", "Fo");
        s = s.replaceAll("5", "Fi");
        s = s.replaceAll("6", "Si");
        s = s.replaceAll("7", "Se");
        s = s.replaceAll("8", "Ei");
        s = s.replaceAll("9", "Ni");
        return s;
    }

}
