package coring;

/**
 * Configuration.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public class OptConfig {
    static String LONG_ARG_PREFIX = "--";
    static String SHORT_ARG_PREFIX = "-";

    static final String LIST_SEPARATOR = ",";
    static final String REQUIRED_HELP = "*";

    public static void setDefault() {
        LONG_ARG_PREFIX = "--";
        SHORT_ARG_PREFIX = "-";
    }

    public static void setLongArgPrefix(String s) {
        if (s == null) {
            throw new NullPointerException();
        }
        if (s.equals(SHORT_ARG_PREFIX) || s.matches(".*\\s.*")) {
            throw new IllegalArgumentException();
        }
        LONG_ARG_PREFIX = s;
    }

    public static void setShortArgPrefix(String s) {
        if (s == null) {
            throw new NullPointerException();
        }
        if (s.equals(LONG_ARG_PREFIX) || s.matches(".*\\s.*")) {
            throw new IllegalArgumentException();
        }
        SHORT_ARG_PREFIX = s;
    }
}
