package coring;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public class OptParserStatus {
    private Exception ex;

    /** true if options are parsed successfully */
    private boolean isSuccessfullyParsed;

    public boolean isSuccessfullyParsed() {
        return isSuccessfullyParsed;
    }

    public boolean isError() {
        return ex != null;
    }

    public String getExceptionMsg() {
        if (ex == null) {
            return null;
        } else if (ex.getMessage() == null) {
            StringWriter sw = new StringWriter();
            ex.printStackTrace(new PrintWriter(sw));
            return sw.getBuffer().toString();
        } else {
            return ex.getMessage();
        }
    }

    public Exception getException() {
        return ex;
    }

    void setSuccessfullyParsed(boolean f) {
        isSuccessfullyParsed = f;
    }

    void setException(Exception e) {
        ex = e;
    }
}
