package coring;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Can be used to mark a method that should be executed when all the arguments
 * are parsed and values are assigned. Only methods that have zero arguments are
 * invoked. If method returns a value, the value is ignored.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface OptPostprocess {
}
