package coring;

import java.util.Arrays;
import java.util.List;

/**
 * {@link Opt} of type {@link List<String>}.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 */
public class StringLst extends Opt<List<String>> {

    public StringLst(String name) {
        this(name, null);
    }

    public StringLst(String name, String shortName) {
        super(name, shortName, List.class, null);
    }

    @Override
    protected void setVal(String[] args, int index) {
        s(Arrays.asList(args[index + 1].split(OptConfig.LIST_SEPARATOR)));
    }

    @Override
    protected String getArgArgumentString() {
        return "STRING_0,STRING_1,...,STRING_N";
    }

    @Override
    public StringLst s(List<String> v) {
        unsafeSet(v);
        return this;
    }
}
