package coco.runtime;

import java.util.Collections;
import java.util.Set;
import java.util.TreeSet;

/**
 * This class is thread safe.
 * 
 * @author Milos Gligoric (milos.gligoric@gmail.com)
 * @author Rohan Sharma (sharma.rohan1990@gmail.com)
 */
public class StateSet implements IStateSet {

    private Set<String> states = Collections.synchronizedSet(new TreeSet<String>());

    @Override
    public void add(String state) {
        states.add(state);
    }

    @Override
    public boolean contains(String state) {
        return states.contains(state);
    }

    @Override
    public long size() {
        return states.size();
    }

    @Override
    public void clear() {
        states.clear();
    }

    @Override
    public String[] states() {
        return states.toArray(new String[0]);
    }

}
