package example.heaparray;

public class HeapArray {

    private int EMPTY_VALUE = -1;

    public int size;
    public int array[];
    public int arraylength;

    public HeapArray() {
        array = new int[0];
    }

    public int getSize() {
        return size;
    }

    private void resize(int newsize, boolean isInsert) {
        int[] newArray = new int[newsize];
        if (array != null && newArray != null) {
            for (int i = 0; i < (isInsert ? size : newsize); i++) {
                newArray[i] = array[i];
            }
        }
        array = newArray;
        arraylength = newsize;
    }

    public void insert(int value) {
        if (size == arraylength) {
            resize(size + 1, true);
        }
        array[size] = value;
        int i = size;
        while (true) {
            int parent = (i - 1) / 2;
            if (parent < 0) {
                break;
            }
            if (array[i] > array[parent]) {
                int temp = array[i];
                array[i] = array[parent];
                array[parent] = temp;
                i = parent;
            } else {
                break;
            }
        }
        size++;
    }

    public int remove() {
        if (size == 0) {
            return EMPTY_VALUE;
        }
        int ret = array[0];
        array[0] = array[size - 1];
        if (size == arraylength) {
            resize(size - 1, false);
        }
        size--;
        int i = 0;
        while (size != 0) {
            int left = 2 * i + 1;
            int right = 2 * i + 2;
            if (left >= size) {
                break;
            }
            if (array[i] < array[left]) {
                int temp = array[i];
                array[i] = array[left];
                array[left] = temp;
                i = left;
                continue;
            }
            if (right >= size) {
                break;
            }
            if (array[i] < array[right]) {
                int temp = array[i];
                array[i] = array[right];
                array[right] = temp;
                i = right;
            }
            size--;
        }
        return ret;
    }

    @Override
    public String toString() {
        String s = "[ size = " + size + " ][ length = " + array.length + " ] { ";
        for (int i = 0; i < array.length; i++) {
            if (i == 0) {
                s += "[ROOT]";
            } else {
                if (i % 2 == 1 && i + 1 < array.length) {
                    s += array[i] <= array[i + 1] ? "[L, G] " : "[G, L]";
                    i++;
                } else {
                    s += "[L]";
                }
            }
        }
        return s += "}";
    }

}
